package com.fs.his.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.fs.common.core.domain.R;
import com.fs.his.domain.FsUserInformationCollection;
import com.fs.his.dto.FsUserInformationCollectionDTO;
import com.fs.his.param.CollectionInfoConfirmParam;
import com.fs.his.param.FsUserInformationCollectionListDParam;
import com.fs.his.param.FsUserInformationCollectionParam;
import com.fs.his.param.UserInformationDoctorType2Param;
import com.fs.his.vo.FsUserInfoCollectionUVO;
import com.fs.his.vo.FsUserInformationCollectionAndPatientVO;
import com.fs.his.vo.FsUserInformationCollectionListDVO;
import com.fs.his.vo.FsUserInformationCollectionVO;

import java.util.List;

/**
 * 用户信息采集Service接口
 *
 * @author fs
 * @date 2025-10-14
 */
public interface IFsUserInformationCollectionService extends IService<FsUserInformationCollection>{
    /**
     * 查询用户信息采集
     *
     * @param id 用户信息采集主键
     * @return 用户信息采集
     */
    FsUserInformationCollection selectFsUserInformationCollectionById(Long id);



    /**
     * 查询用户信息采集列表
     *
     * @param fsUserInformationCollection 用户信息采集
     * @return 用户信息采集集合
     */
    List<FsUserInformationCollection> selectFsUserInformationCollectionList(FsUserInformationCollection fsUserInformationCollection);

    List<FsUserInformationCollection> selectFsUserInformationCollectionByDoctorType2(UserInformationDoctorType2Param userInformationDoctorType2Param);
    List<FsUserInformationCollection> selectFsUserInformationCollectionByDoctorType1(UserInformationDoctorType2Param userInformationDoctorType2Param);

    /**
     * 新增用户信息采集
     *
     * @param fsUserInformationCollection 用户信息采集
     * @return 结果
     */
    Long insertFsUserInformationCollection(FsUserInformationCollectionParam fsUserInformationCollection);

    /**
     * 修改用户信息采集
     *
     * @param fsUserInformationCollection 用户信息采集
     * @return 结果
     */
    Long update(FsUserInformationCollectionParam fsUserInformationCollection);

    /**
     * 修改用户信息采集
     *
     * @param fsUserInformationCollection 用户信息采集
     * @return 结果
     */
    Long updateFsUserInformationCollection(FsUserInformationCollectionParam fsUserInformationCollection);

    /**
     * 批量删除用户信息采集
     *
     * @param ids 需要删除的用户信息采集主键集合
     * @return 结果
     */
    int deleteFsUserInformationCollectionByIds(Long[] ids);

    /**
     * 删除用户信息采集信息
     *
     * @param id 用户信息采集主键
     * @return 结果
     */
    int deleteFsUserInformationCollectionById(Long id);


    FsUserInformationCollectionVO getInfo(FsUserInformationCollection fsUserInformationCollection);

    /**
     * 查询医生端用户信息采集列表(只查询未关联套餐包的信息采集)
     * @param param
     * @return
     */
    List<FsUserInformationCollectionListDVO> selectFsUserInformationCollectionListDVO(FsUserInformationCollectionListDParam param);

    FsUserInformationCollectionVO detail(Long id);

    R getWxaCodePackageOrderUnLimit(Long collectionId);

    R doctorConfirm(FsUserInformationCollection collection);
    R doctorType2Confirm(FsUserInformationCollection collection);

    FsUserInfoCollectionUVO info(Long id, Long userId);

    R userConfirm(CollectionInfoConfirmParam param);

    //自动退款
    void autoRefund(FsUserInformationCollection collection);

    FsUserInformationCollectionVO getCollectionByUserId(Long userId);

    FsUserInformationCollectionDTO selectFsUserInformationCollectionDTOById(Long id);

    int updatePackageOrderCode(FsUserInformationCollection fsUserInformationCollection);

    FsUserInformationCollectionAndPatientVO selectFsUserInformationCollectionVoById(Long id);
}
